--- create demo data ----
create table #my_emails 
	(
	 Id int 
	,Customer_Ref varchar(25)
	,Email_Address varchar(25)
	,jKey uniqueidentifier
	,Email_Body_HTML varchar(1000)
	)

create table #my_email_body_rows
	(
	 Id int
	,Id_Row int
	,Line varchar(10)
	,Part_Number varchar(10)
	,Part_Desc varchar(10)
	,Qty varchar(3)
	)

insert #my_emails (Id, Customer_Ref, Email_Address, jKey)
values (1, 'Bob Slydell', 'info@fuel9.com', NEWID())

insert #my_emails (Id, Customer_Ref, Email_Address, jKey)
values (2, 'Bob Porter', 'info@fuel9.com', NEWID())

insert #my_email_body_rows
values (1, 100, '10', '4567', 'Bike A', '3')

insert #my_email_body_rows
values (1, 101, '20', '1267', 'Bike C', '1')

insert #my_email_body_rows
values (1, 102, '30', '5567', 'Bike D', '12')

insert #my_email_body_rows
values (2, 103, '10', '5567', 'Bike D', '1')

insert #my_email_body_rows
values (2, 104, '20', '8990', 'Bike E', '1')

--- declarations ---
declare 
	 @gKey uniqueidentifier
	,@Email_Subjuect varchar(25)
	,@Email_Body_HTML varchar(1000)
	,@Id int
	,@Customer_Ref varchar(25)
	,@Id_Row int
	,@Line varchar(10)
	,@Part_Number varchar(10)
	,@Part_Desc varchar(10)
	,@Qty varchar(3)

set @gKey = NEWID()


--- email loop ---
while 1 = 1
	begin
		--- get email records ---
		select top 1 
		  @Id = Id
		, @Customer_Ref = Customer_Ref 
		from #my_emails 
		where Email_Body_HTML is null

		--- break loop if no more records ---
		if @@ROWCOUNT = 0 break

		--- set beginning of HTML string ---
		set @Email_Body_HTML = '<!DOCTYPE html><html><body>Dear ' + @Customer_Ref + ',<br>' +
                               'We are happy to let you know that your order...<br><br>' +
                               '<table><tr><td>Line</td><td>Part Number</td><td>Desc</td><td>Qty</td></tr>' 

		--- email body loop ---
		while 1 = 1
			begin
				select top 1
				  @Id_Row = Id_Row
				, @Line = Line
				, @Part_Number = Part_Number
				, @Part_Desc = Part_Desc
				, @Qty = Qty
				from #my_email_body_rows
				where Id = @Id

				--- break loop if no more records ---
				if @@ROWCOUNT = 0 break

				--- update HTML string ---
				set @Email_Body_HTML = @Email_Body_HTML + 
				                      '<tr><td>' + @Line + '</td><td>' + @Part_Number + '</td><td>' + 
									  @Part_Desc + '</td><td>' + @Qty + '</td></tr>' 

				delete from #my_email_body_rows where Id_Row = @Id_Row

			end
		
		--- set end of HTML string ---
		set @Email_Body_HTML = @Email_Body_HTML + '</table></body></html>'

		--- update temp table with email body ---
		update #my_emails 
		set Email_Body_HTML = @Email_Body_HTML
		where Id = @Id

		--- reset HTML string ---
		set @Email_Body_HTML = null

	end
	

--- email out ----
insert [dbo].[EVENT_MASTER] 
	(
	gKey
	)
values
	(
	@gKey
	)

insert [dbo].[OUT_EMAIL]
	(
	 gKey
	,jKey
	,[Subject]
	,Body
	,IncludeKey
	)
select
	 @gKey
	,jKey
	,'Order Id: ' + CAST(Id as varchar(3))
	,Email_Body_HTML
	,0 -- don't include tracking key
from #my_emails

insert [dbo].[OUT_EMAIL_RECIPIENT]
	(
	 jKey
	,Email
	)
select
	 jKey
	,Email_Address
from #my_emails

update [dbo].[EVENT_MASTER]
set [Status] = 0
where gKey = @gKey


drop table #my_emails
drop table #my_email_body_rows

